<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    @submit="onSubmitHandler"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Фамилия "
          v-model="formData.lastName"
          :required="true"
          placeholder="Введите фамилию"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Имя "
          v-model="formData.firstName"
          :required="true"
          placeholder="Введите имя"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Отчество (необязательно)"
          v-model="formData.patronym"
          placeholder="Введите отчество"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          label="Email"
          v-model="formData.email"
          placeholder="Введите email"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Статус "
          v-model="formData.isActive"
          :items="allowedStatus"
          :required="true"
          placeholder=""
          display-exp="value"
          :is-standart="true"
          value-exp="key"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Список ролей "
          v-model="formData.workerRoles"
          :items="availableRoles"
          placeholder="Все варианты выбраны"
          display-exp="title"
          :is-dropdown="true"
          :is-multiselect="true"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import models from '@/models'

import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
import ObForm              from 'common-components/src/obComponents/obForm';
import ObInput             from 'common-components/src/obComponents/obInput';
import ObSelect            from 'common-components/src/obComponents/obSelect';

export default {
  name: 'AddUser',
  components: {
    ObForm,
    ObInput,
    ObSelect
  },
  props: {
    availableRoles: {
      type: Array,
      required: true
    }
  },
  mixins: {
    FormValidationMixin
  },
  data () {
    return {
      formData: {
        isActive   : false,
        workerRoles: [],
        lastName   : '',
        firstName  : '',
        patronym   : '',
        email      : ''
      },
      dataIsChanged: false,
      selectedStatus: 'Активен',
      selectedRoles: [],
    }
  },
  computed: {
    formModel: () => models.user.add,

    allowedStatus () {
      return [
        { key: false, value: 'Заблокирован' },
        { key: true,  value: 'Активен' }
      ]
    },

    items () {
      const availableRoles = this.selectedRoles.map(el => el.value)
      return this.availableRoles
        .filter(el => !availableRoles.includes(el.userRole))
        .map(el => ({ key: el.uuid, value: el.userRole }))
    },

  },
  methods: {

    close () {
      this.$emit('close')
      this.clear()
    },

    clear () {
      this.formData = {
        isActive   : false,
        workerRoles: [],
        lastName   : '',
        firstName  : '',
        patronym   : '',
        email      : ''
      }
    },

    onSubmitHandler () {
      this.$emit('save', this.formData);
    }
  }

}
</script>
